; **
; Intellivision for GameBoy Color v1.1
; Copyright(C) 2000,03 By Carl Mueller, Jr.
;
; This program is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2 of the License, or
; (at your option) any later version.
;
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with this program; if not, write to the Free Software
; Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

; **
; EXEC_1523:
;

EXEC_1523::

        ld              sp, GH_STACK + 8  ; use GH_STACK for HOME_1523

;        ld              a, [UDB_Flag]
;        dec             a               ; is UDB_Flag = 1 ?
;        jr              nz, .Skip       ; no, so UDB is up-to-date
;
;        ld              [UDB_Flag], a   ; set UDB_Flag = 0
;
;        call            UDB_Update
;.Skip
        ld              c, -2           ; check the LEFT hand first

GH_ChkRight:                            ; check the RIGHT hand second

        inc             c
        inc             c               ; c = 0 if LEFT, 2 if RIGHT

        ld              h, SCRATCHPAD_RAM >> 8 + 1

        ld              a, ( $FF * 2 ) & $FF
        sub             c               ; a = $FF * 2 (L) / $FE * 2 (R)
        ld              l, a            ; hl -> HardCode

        ld              a, [hl]         ; a <- HardCode
        cpl                             ; invert bits so 1=DOWN, 0=UP
        ld              b, a            ; save "HandData" in b

        dec             h               ; pos @ SCRATCHPAD_RAM "low"

        ld              a, c            ; a = 0 if LEFT, 2 if RIGHT
        add             $23 * 2         ;   = $23 * 2 (L) / $24 * 2 (R)
        ld              l, a            ; hl -> prev. HandData

        ld              a, [hl]         ; a <- prev. HandData
        cp              b               ; is cur. HandData = prev. HandData ?
        jr              nz, .HandDiff   ; no, so check for control releases

        ; hand data is same, so find out what's being pressed & handle it

        ld              l, a
        ld              h, HDToHndlr >> 9

        add             hl, hl          ; hl -> HDToHndlr[ HandData * 2 ]

        ld              a, [hl+]
        ld              h, [hl]
        ld              l, a            ; hl <- handler's address

        jp              [hl]            ; jump to appropriate handler

.HandDiff

        ; hand data is different, so check if side button previously pressed

        ld              [hl], b         ; set prev. HandData = cur. HandData

        ld              a, c            ; a = 0 if LEFT, 2 if RIGHT
        add             $21 * 2         ;   = $21 * 2 (L) / $22 * 2 (R)
        ld              l, a            ; hl -> prev. SideBtnNum

        ld              a, [hl]         ; a <- prev. SideBtnNum # (0=NONE,
                                        ;      1=UPPER, 2=LEFT, 3=RIGHT)
        add             a, a            ; was any side button pressed ?
        jr              z, GH_DU2       ; no, so check if disc was released

        ; -------------------------------------------------------------------
        ;      Side button released -- dispatch to HANDTAB #4, #6, or #8
        ; -------------------------------------------------------------------

        ; side button considered released, even though may still be down

        push            bc              ; [GH_STACK + 6] <- c (LeftRight)

        add             2
        ld              b, a            ; set HANDTAB offset = 4, 6, or 8

        xor             a
        ld              [hl], a         ; set prev. SideBtnNum = 0 (none)

        dec             a               ; [R0] <- -1          (ControlCode)
        ld              de, $155E       ; [R5] <- $155E       (RetAddr)

        call            GH_Dispatch_1   ; return only if HandHndlrAddr = 0

EXEC_155E::                             ; return from side button release

        ld              sp, GH_STACK + 6

        pop             bc              ; c <- 0 if LEFT, 1 if RIGHT

GH_DU1: ld              h, SCRATCHPAD_RAM >> 8

GH_DU2: ld              a, c            ; a = 0 if LEFT, 2 if RIGHT
        add             $1F * 2         ;   = $1F * 2 (L) / $20 * 2 (R)
        ld              l, a            ; hl -> prev. KeyPadNum / DiscPos

        ld              a, [hl]         ; a <- prev. KeyPadNum / DiscPos

        set             6, [hl]         ; set bit #6 (released)

        and             $C0             ; KeyPad or already "released" ?
        jr              nz, GH_EX2      ; yes, so Disc was not released

        ; -------------------------------------------------------------------
        ;               Disc released - dispatch to HANDTAB #0
        ; -------------------------------------------------------------------

        push            bc              ; [GH_STACK + 6] <- c (LeftRight)

        ld              b, a            ; set HANDTAB offset = 0 (DISC)

        dec             a               ; [R0] <- -1          (ControlCode)
        ld              de, $152A       ; [R5] <- $152A       (RetAddr)

        call            GH_Dispatch_1   ; return only if HandHndlrAddr = 0

EXEC_152A::                             ; return from disc release

        ld              sp, GH_STACK + 6

GH_EX1: pop             bc              ; c <- 0 if LEFT, 1 if RIGHT

GH_EX2: ld              a, c            ; a = 0 if LEFT, 2 if RIGHT
        or              a               ; did we just check the LEFT hand ?
        jr              z, GH_ChkRight  ; yes, so now check the RIGHT

        ld              bc, rROMB0 + cROMB0 & $FF  ; *

        jp              ifMVI@_R6_R7    ; let's save just a little code

        ; -------------------------------------------------------------------
        ;  Handle both Keypad (K0-K9, KC, and KE) and Disc presses (D0-D15)
        ; -------------------------------------------------------------------

POS_NUM SET             15
        REPT            16              ; do disc positions 15..0

POS     EQUS            STRSUB( "{POS_NUM}", 2, 1 )
LABEL   EQUS            "GH_D{POS}"

LABEL:  ld              d, POS_NUM

        IF              POS_NUM != 0
        jr              GH_Disc
        ENDC

POS_NUM SET             POS_NUM + -1
        PURGE           POS, LABEL
        ENDR

GH_Disc:                                ; handle both Keypad and Disc presses

        ld              h, SCRATCHPAD_RAM >> 8

        ld              a, c            ; a = 0 if LEFT, 2 if RIGHT
        add             $1F * 2         ;   = $1F * 2 (L) / $20 * 2 (R)
        ld              l, a            ; hl -> prev. KeyPadNum / DiscPos

        ld              a, d            ; a = cur. KeyPadNum / DiscPos
        cp              [hl]            ; is it = prev. KeyPadNum / DiscPos ?
        jr              z, GH_EX2       ; yes, so only dispatch the 1st time

        ld              [hl], a         ; prev. KeyPadNum / DiscPos = cur.

        rlca
        rlca                            ; put bit #7 (KeyPad) in bit #1
        and             $02             ; and isolate it

        ld              b, a            ; b = 0 if DISC, 2 if KEYPAD

        push            bc              ; [GH_STACK + 6] <- c (LeftRight)
                                        ; [GH_STACK + 7] <- b (HandTabOfs)

        ; KeyPadNum / DiscPos new, so now see if its "click" option is set

        ld              a, [ehKeyClicks]  ; a <- KeyClicks ([UDB - 8])

        jr              z, .DiscClk

        rrca                            ; do Keypad presses "click" ?
.DiscClk
        rrca                            ; do Disc presses "click" ?
        jr              nc, GH_NoKyClk  ; no, so skip click setup

        ld              l, $49 * 2      ; hl -> SNDHNDLR

        ld              a, [hl]         ; a <- SNDHNDLR
        or              a               ; is it = 0 (nothing playing) ?
        jr              nz, GH_NoKyClk  ; no, so don't let click interrupt

        ; "click" option set, and no sounds playing, so let EXEC setup sound

        push            de              ; [GH_STACK + 5] <- d (ControlCode)

        ld              hl, R5          ; hl -> R5

        ld              [hl], $E5
        inc             l
        ld              [hl], $15       ; [R5] <- $15E5 (RetAddr)

        ld              bc, rROMB0 + cROMB0 & $FF

        di                              ; disable interrupts to restore stack

        ld              sp, $4C14       ; transfer control to EXEC @ $160A

        reti                            ; return, enabling interrupts

EXEC_15E5::                             ; return from keypad / disc click

        ld              sp, GH_STACK + 4

        pop             de              ; d <- K0-KE/D0-D15   (ControlCode)
        pop             bc              ; c <- 0/1            (LeftRight)
                                        ; b <- 0/2            (HandTabOfs)

        push            bc              ; [GH_STACK + 6] <- c (LeftRight)
                                        ; [GH_STACK + 7] <- b (HandTabOfs)

        ld              h, SCRATCHPAD_RAM >> 8

GH_NoKyClk:

        ld              a, d
        and             $7F             ; [R0] <- K0-KE/D0-D15  (ControlCode)
        ld              de, $152A       ; [R5] <- $152A         (RetAddr)

        call            GH_Dispatch_1   ; return only if HandHndlrAddr = 0

        jp              GH_EX1

KEY_NUM SET             0
        REPT            12              ; do keypad numbers 0..11

KEY     EQUS            STRSUB( "{KEY_NUM}", 2, 1 )
LABEL   EQUS            "GH_K{KEY}"

LABEL:  ld              d, $80 + KEY_NUM
;        IF              KEY_NUM != 11
        jr              GH_Disc
;        ENDC

KEY_NUM SET             KEY_NUM + 1
        PURGE           KEY, LABEL
        ENDR

        ; -------------------------------------------------------------------
        ; Handle "action" buttons (UPPER, LOWER LEFT, and LOWER RIGHT)
        ; -------------------------------------------------------------------

GH_A3:  ld              de, $0308       ; d = RIGHT, e = HANDTAB #8
        jr              GH_Action

GH_A2:  ld              de, $0206       ; d = LEFT,  e = HANDTAB #6
        jr              GH_Action

GH_A1:  ld              de, $0104       ; d = UPPER, e = HANDTAB #4

GH_Action:

        ld              hl, SCRATCHPAD_RAM + $01E * 2

        ld              [hl], $19       ; set HIGH byte of ScrnSaver = $19

        ld              a, c            ; a = 0 if LEFT, 2 if RIGHT
        add             $21 * 2         ;   = $21 * 2 (L) / $22 * 2 (R)
        ld              l, a            ; hl -> prev. SideBtnNum

        push            bc              ; [GH_STACK + 6] <- c  (LeftRight)
                                        ; [GH_STACK + 7] <- b  (HandData)

        ld              a, [hl]         ; a <- prev. SideBtnNum
        sub             d               ; cur. SideBtnNum = prev. SideBtnNum ?
        jr              z, GH_OldPress  ; yes, so already handled "new" press

        ; side button pressed, but not previously recorded as being so

        ld              [hl], d         ; prev. SideBtnNum = cur. SideBtnNum

        ld              a, [ehKeyClicks]  ; a <- KeyClicks ([UDB - 8])

        rrca
        rrca                            ; side button "clicks" in bits 0-2
.GetClk
        rrca                            ; correct side button "click" in CY

        dec             d               ; dec SideBtnNum
        jr              nz, .GetClk     ; if not zero, keep shifting into CY
        jr              nc, GH_NoSdClk  ; side button "click" not set, skip

        ; "click" option set, but don't play unless no other sounds playing

        ld              l, $49 * 2      ; hl -> SNDHNDLR

        ld              a, [hl]         ; a <- SNDHNDLR
        or              a               ; is it = 0 (nothing playing) ?
        jr              nz, GH_NoSdClk  ; no, so don't let click interrupt

        ; no sounds playing, so go ahead and let EXEC finish the setup

        push            de              ; [GH_STACK + 4] <- e (HandTabOfs)

        ld              hl, R5          ; hl -> R5

        ld              [hl], $85
        inc             l
        ld              [hl], $15       ; [R5] <- $1585 (RetAddr)

        ld              bc, rROMB0 + cROMB0 & $FF

        di                              ; disable interrupts to restore stack

        ld              sp, $4C14       ; transfer control to EXEC @ $160A

        reti                            ; return, enabling interrupts

EXEC_1585::                             ; return from side button click

        ld              sp, GH_STACK + 4

        pop             de              ; e <- 4/6/8          (HandTabOfs)
        pop             bc              ; c <- 0/1            (LeftRight)
                                        ; b <- ??             (HandData)

        push            bc              ; [GH_STACK + 6] <- c (LeftRight)
                                        ; [GH_STACK + 7] <- b (HandData)

        ld              h, SCRATCHPAD_RAM >> 8

GH_NoSdClk:

        ld              a, 1            ; [R0] <- 1           (ControlCode)

GH_OldPress:

        ld              b, e            ; set HANDTAB offset = 4, 6, or 8

        ld              de, $158E       ; [R5] <- $158E        (RetAddr)

        call            GH_Dispatch_2   ; return only if HandHndlrAddr = 0

EXEC_158E::                             ; return from side button dispatch

        ld              sp, GH_STACK + 6

        pop             bc              ; c <- LeftRight (0=LEFT, 1=RIGHT)
                                        ; b <- HandData (inverted HW code)

        ; handled action buttons, now handle any possible disc presses

        ld              a, b            ; a = HandData (inverted HW code)
        and             $1F             ; isolate bits 0-4 (disc bits only)
        add             a, a            ; shift for word-table look-up

        ld              l, a
        ld              h, HDToHndlr >> 8  ; hl -> HDToHndlr[ HD.0-4 * 2 ]

        ld              a, [hl+]
        ld              h, [hl]
        ld              l, a            ; hl <- address of handler for HD

        jp              [hl]            ; jump to appropriate handler

